3 # Copyright (c) 2000-2002 Timothy M. King (tmk@lordzork.com)
5 # Permission is hereby granted, free of charge, to any person obtaining a
6 # copy of this software and associated documentation files (the "Software"),
7 # to deal in the Software without restriction, including without limitation
8 # the rights to use, copy, modify, merge, publish, distribute, sublicense,
9 # and/or sell copies of the Software, and to permit persons to whom the
10 # Software is furnished to do so, subject to the following conditions:
12 # The above copyright notice and this permission notice shall be included in
13 # all copies or substantial portions of the Software.
15 # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
16 # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
17 # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
18 # THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
19 # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
20 # FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
21 # DEALINGS IN THE SOFTWARE.
23 PATH
=$PATH:/usr
/bin
:/usr
/local
/bin
:/usr
/X
11R
6/bin
25 display_full_cmd
="display -geometry 800x600 -window root"
26 display_tile_cmd
="display -window root"
27 display_center_cmd
="display -backdrop -window root"
28 display_default_cmd
="$display_center_cmd"
30 Esetroot_full_cmd
="Esetroot -scale"
31 Esetroot_tile_cmd
="Esetroot"
32 Esetroot_center_cmd
="Esetroot -c"
33 Esetroot_default_cmd
="$Esetroot_center_cmd"
35 wmsetbg_full_cmd
="wmsetbg -s -S"
36 wmsetbg_tile_cmd
="wmsetbg -t"
37 wmsetbg_center_cmd
="wmsetbg -e"
38 wmsetbg_default_cmd
="$wmsetbg_center_cmd"
40 qiv_full_cmd
="qiv --root_s"
41 qiv_tile_cmd
="qiv --root_t"
42 qiv_center_cmd
="qiv --root"
43 qiv_default_cmd
="$qiv_center_cmd"
45 xv_full_cmd
="xv -max -smooth -root -quit"
46 xv_tile_cmd
="xv -root -quit"
47 xv_center_cmd
="xv -rmode 5 -root -quit"
48 xv_default_cmd
="$xv_center_cmd"
50 xli_full_cmd
="xli -fullscreen -onroot -quiet"
51 xli_tile_cmd
="xli -onroot -quiet"
52 xli_center_cmd
="xli -center -onroot quiet"
53 xli_default_cmd
="$xli_center_cmd"
55 xsetbg_full_cmd
="xsetbg -fillscreen"
56 xsetbg_tile_cmd
="xsetbg"
57 xsetbg_center_cmd
="xsetbg -center"
58 xsetbg_default_cmd
="$xsetbg_center_cmd"
60 img_apps
="qiv xli xv wmsetbg Esetroot display xsetbg"
63 copyright
="(c) 2000-$(date +%Y) by Timothy M. King (http://lordzork.com/)"
64 config
=$HOME/.bsetbgrc
65 last_cmd_file
=$HOME/.bsetbg_last_cmd
70 [ "$1" ] && rc
=$1 && shift 1
71 [ "$*" ] && echo -e $
*
77 [yY
][eE
][sS
]|1|[yY
]|[tT
][rR
][uU
][eE
]|[oO
][nN
]) : ;;
85 elif [ -x "$(which $1 2>/dev/null)" ]; then
87 elif [ -x "$(type $1 2>/dev/null)" ]; then
96 $me $version $copyright
98 -center <file> center an image on the desktop
99 -tile <file> tile an image on the desktop
100 -full <file> stretch an image to fill the desktop
101 -exec <args> <file> specify an external command to execute
103 -post <string> arguments to be passed to the post-command
104 -debug prints commands without executing them
107 # this is extremely lame, but probably more portable than grep -E
108 bsetroot_help
=$(bsetroot -help 2>&1| grep -v "^bsetroot" | grep -v "^ -help")
109 case $bsetroot_help in
110 BaseDisplay
*) echo ;;
111 *-gradient*) echo "$bsetroot_help"
115 -generate <string> generate a config file
117 -version output version information
123 for a
in $img_apps; do
124 if check_exe_in_path
$a; then
125 eval center_cmd
=\$
$a\_center_cmd
126 eval full_cmd
=\$
$a\_full_cmd
127 eval tile_cmd
=\$
$a\_tile_cmd
128 eval default_cmd
=\$
$a\_default_cmd
131 if [ "$not_found" ]; then
132 not_found
="$not_found $a"
142 echo -e "# created by $me $version on $(date)\n#"
143 echo -e "# seting NO_EXEC to a boolean value (eg true/false) will cause $me"
144 echo -e "# to never modify the root window\n#"
145 echo -e "#NO_EXEC=\n#"
146 echo -e "# POST_COMMAND can be set to a command that will be run run every time"
147 echo -e "# $me sets the root image\n#"
148 echo -e "#POST_COMMAND=\n#"
149 echo -e "# if LOG_LAST_CMD is set (boolean), bsetbg will keep a log of the last"
150 echo -e "# two successful commands.\n#"
151 echo -e "#LOG_LAST_CMD=\n#"
152 echo -e "# the LOGFILE specifies the file that bsetbg uses when LOG_LAST_CMD"
153 echo -e "# is defined. this defaults to ~/.bsetbg_last_cmd .\n#"
154 echo -e "#LOGFILE=\n#"
155 echo -e "# the following are default configuration values for the most popular image"
156 echo -e "# programs. See the man page of the respective application for more info.\n"
158 [ "$*" ] && img_apps
="$*"
160 for a
in $img_apps; do
161 if check_exe_in_path
$a; then
162 if ! bool
$have_match; then
164 [ "$(eval echo \$$a\_center_cmd)" ] &&
165 eval echo CENTER
=$q\$
$a\_center_cmd
$q &&
167 [ "$(eval echo \$$a\_full_cmd)" ] &&
168 eval echo FULL
=$q\$
$a\_full_cmd
$q &&
170 [ "$(eval echo \$$a\_tile_cmd)" ] &&
171 eval echo TILE
=$q\$
$a\_tile_cmd
$q &&
173 [ "$(eval echo \$$a\_default_cmd)" ] &&
174 eval echo -e DEFAULT
=$q\$
$a\_default_cmd
$q \\\\n
&&
178 [ "$(eval echo \$$a\_center_cmd)" ] &&
179 eval echo \\#CENTER=$q\$$a\_center_cmd$q
181 [ "$(eval echo \$$a\_full_cmd)" ] &&
182 eval echo \\#FULL=$q\$$a\_full_cmd$q
184 [ "$(eval echo \$$a\_tile_cmd)" ] &&
185 eval echo \\#TILE=$q\$$a\_tile_cmd$q
187 [ "$(eval echo \$$a\_default_cmd)" ] &&
188 eval echo -e \\#DEFAULT=$q\$$a\_default_cmd$q \\\\n
196 if check_exe_in_path bsetroot
; then
199 $debug bsetroot $
* 2>/dev
/null
; rc
=$?
201 if [ "$rc" -gt 0 ]; then
204 log_cmd bsetroot $
*; $refresh_cmd 2>/dev
/null
207 quit
1 "couldn't find bsetroot in $PATH"
212 [ -z "$1" ] && help_msg
1
214 bool
$noconfig || read_config
217 check_img_command
$do_this
224 if [ -f "$file" ]; then
225 exec_img_command
$do_this $file
227 quit
1 "$file does not exist"
232 [ "$#" -lt 3 ] && help_msg
3
234 bool
$noconfig || read_config
236 # check to see if -*c, -*f, or -*t were spcified, if so
237 # assume the last argument is a filename
238 b_arg
=$(eval echo \$$(( $# - 1 )) )
242 -c|*-center|c
|-t|*-tile*|t
|-f|*-full|f
)
244 f_args
="$b_arg $file"
247 # put the rest of the arguments into the varialbe $e_args
252 *) e_args
="$e_args "$1""
258 # with $f_args defined, check for image and do things normally
259 if [ "$f_args" ]; then
260 [ ! -f "$file" ] && quit
1 "$file does not exist"
262 if check_img_command
$e_args; then
266 get_img_command
$f_args
267 check_img_command
$do_this
268 echo "$p couldn't find '$app' in path, using $type command instead"
270 # without $f_args, run the command blindly if it's in $PATH
271 elif check_exe_in_path
$e_args; then
274 quit
1 "$p unable to run the following command: $e_args"
277 exec_img_command
$do_this $file
282 *-full|-f|f
) type=full
; do_this
="$full_cmd" ;;
283 *-tile|-t|t
) type=tile
; do_this
="$tile_cmd" ;;
284 *-center|-c|c
) type=center
; do_this
="$center_cmd" ;;
285 *) type=default
; do_this
="$default_cmd"
289 check_img_command
() {
290 if check_exe_in_path
$1; then
297 quit
1 "$p couldn't find a suitable image program. tried the following:\\n
298 $(for a in $not_found; do echo " $a\\n"; done)"
301 if [ "$rc" -gt 0 -a -z "$e_args" ] && bool
$read_config; then
302 echo "$p couldn't find a suitable $type command in $config"
312 if [ "$debug" ]; then
315 $command >/dev
/null
2>&1; rc
=$?
318 if [ "$rc" -gt 0 ]; then
319 echo "$p '$command' exited with status $rc"
322 parse_args
${f_args:-$my_args}
323 echo "$p using '$command' as $type"
324 $debug $command >/dev
/null
2>&1; rc
=$?
325 [ "$rc" = 0 ] && log_cmd
$do_this $file && $refresh_cmd 2>/dev
/null
327 log_cmd
$do_this $file; xrefresh
2>/dev
/null
333 bool
$LOG_LAST_CMD || return 1
334 [ "$debug" ] && return 1
335 echo -e "$prev_cmd\n$*" >$last_cmd_file
340 [ -f $config ] || return 1
342 if bool
$read_config; then
348 .
$HOME/.bsetbgrc
2>/dev
/null
355 last_cmd_file
=${LOGFILE:-$last_cmd_file}
357 bool
$LOG_LAST_CMD && prev_cmd
=$(tail -n 1 $last_cmd_file 2>/dev/null)
362 quit
0 "$p no_exec mode. the root window will not be modified."
366 if [ -n "$POST_COMMAND" -a "$rc" -le 0 ]; then
367 if [ -n "$debug" ]; then
368 $debug "running post_command: $POST_COMMAND $post_args"
370 $POST_COMMAND $post_args 2>/dev
/null
; erc
=$?
372 echo "$p post-command '$POST_COMMAND $post_args' exited with status $erc"
387 [ -z "$1" ] && return 1
388 if [ "$post_args" ]; then
389 post_args
="$post_args $1"
396 if [ -z "$command" ]; then
397 command=${2:-$1}; eval ${3:-${2:-$1}}=1
398 elif bool
$do_post; then
408 unset refresh_cmd
; debug
=echo\
$me\_debug
: ;;
411 unset finished do_std do_exec
; do_post
=1 ;;
413 -c|*-center|c
|-t|*-tile*|t
|-f|*-full|f
)
415 do_std
|do_generate
|do_bsetroot
)
418 if ! bool
$got_fcmd; then
419 add_arg
$1 args
; got_fcmd
=1
424 add_arg
$1; do_std
=1; command=do_std
427 -a|*-app|a
|-e|*-exec|e
)
428 check_cmd
"do_exec" ;;
430 -mod|-gradient|-solid|-display)
431 check_cmd
"do_bsetroot" && add_arg
$1 ;;
434 check_cmd
$1 "do_generate" ;;
437 [ -z "$command" ] && quit
0 $me $version $copyright ;;
440 [ -z "$command" ] && help_msg
;;
443 bool
$finished && return 1
446 bool
$do_exec || bool
$do_bsetroot || bool
$do_post || help_msg
1
449 if bool
$do_std || bool
$do_exec || bool
$do_bsetroot || bool
$do_generate; then
451 elif bool
$do_post; then
454 add_arg
$1; command=do_std
; finished
=1
459 [ -z "$*" ] && help_msg
1